#ifndef UNICODE
#define UNICODE
#endif

#include <stdio.h>
#include <assert.h>
#include <windows.h> 
#include <lm.h>

/*BOOL Privilege(LPTSTR pszPrivilege, BOOL bEnable)
{
     HANDLE           hToken;
     TOKEN_PRIVILEGES tp;

     // obtain the token, first check the thread and then the process
     if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, TRUE, &hToken)){
          if (GetLastError() == ERROR_NO_TOKEN){
               if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
                    return FALSE;
                  }
                  else
                          return FALSE;
         }

     // get the luid for the privilege
     if (!LookupPrivilegeValue(NULL, pszPrivilege, &tp.Privileges[0].Luid)) {
          CloseHandle(hToken);
          return FALSE;
     }

     tp.PrivilegeCount = 1;

     if (bEnable)
          tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
     else
          tp.Privileges[0].Attributes = 0;

     // enable or disable the privilege
     if (!AdjustTokenPrivileges(hToken, FALSE, &tp, 0, (PTOKEN_PRIVILEGES)NULL, 0)) {
          CloseHandle(hToken);
          return FALSE;
     }

     if (!CloseHandle(hToken))
          return FALSE;

     return TRUE;
}*/

void print_help() {
    printf("Usage:\n"
           "  enumuser [-<switches>]\n"
           "Switches:\n"
           "  w  wide information\n");
    exit(0);
}

void wmain (int argc, wchar_t* argv[]) {
    DWORD i, j;
    wchar_t a;

    PVOID pBuf = NULL;
    PVOID pTmpBuf;

    LPWKSTA_USER_INFO_0 pBuf0 = NULL;
    LPWKSTA_USER_INFO_0 pTmpBuf0;

    LPWKSTA_USER_INFO_1 pBuf1 = NULL;
    LPWKSTA_USER_INFO_1 pTmpBuf1;

    DWORD dwLevel = 0;
    DWORD dwPrefMaxLen = -1;
    DWORD dwEntriesRead = 0;
    DWORD dwTotalEntries = 0;
    DWORD dwResumeHandle = 0;
    DWORD dwTotalCount = 0;
    NET_API_STATUS nStatus;
    LPTSTR pszServerName = NULL;

    printf("Console Logged User Enumeration utility for WIndows NT/2000/XP/.NET, v.1.1\n"
           "  Copyright (c) Alexander A. Telyatnikov, 2003-2006\n");

    for(i=1; (int)i<argc; i++) {
        if(!argv[i])
            continue;
        if(argv[i][0] != '-') {
            print_help();
        }
        j=1;
        while((a = argv[i][j]) && (a != ' ') && (a != '\t')) {
            switch(a) {
            case 'w' :
                dwLevel = 1;
                break;
            case '?' :
            default:
                print_help();
            }
/*            case 'F' :
                Flags |= EWX_FORCEIFHUNG;
                break;
            }*/
            j++;
        }
    }


    do // begin do
    {
        CHAR pszServerNameA[MAX_PATH];

        sprintf(pszServerNameA, "%s", pszServerName);
        nStatus = NetWkstaUserEnum(pszServerName ? pszServerNameA : NULL,
                                   dwLevel,
                                   (LPBYTE*)&pBuf,
                                   dwPrefMaxLen,
                                   &dwEntriesRead,
                                   &dwTotalEntries,
                                   &dwResumeHandle);
        // If the call succeeds,
        if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
        {
            if ((pTmpBuf = pBuf) != NULL)
            {
                // Loop through the entries.
                for (i = 0; i < dwEntriesRead; i++)
                {
                    if (pTmpBuf == NULL)
                    {
                        // Only members of the Administrators local group
                        //  can successfully execute NetWkstaUserEnum
                        //  locally and on a remote server.
                        fprintf(stderr, "An access violation has occurred\n");
                        break;
                    }
                    // Print the user logged on to the workstation. 
                    if(dwLevel == 0) {
                        pTmpBuf0 = (LPWKSTA_USER_INFO_0)pTmpBuf;
                        wprintf(L"\t%s\n", pTmpBuf0->wkui0_username);
                        pTmpBuf0++;
                        pTmpBuf= pTmpBuf0;
                    } else
                    if(dwLevel == 1) {
                        pTmpBuf1 = (LPWKSTA_USER_INFO_1)pTmpBuf;
                        wprintf(L"\t%s\\%s auth by %s",
                            pTmpBuf1->wkui1_logon_domain,
                            pTmpBuf1->wkui1_username,
                            pTmpBuf1->wkui1_logon_server
                            );
                        if(pTmpBuf1->wkui1_oth_domains && (pTmpBuf1->wkui1_oth_domains[0]!=0)) {
                            wprintf(L", additional browse domains: %s",
                                pTmpBuf1->wkui1_oth_domains
                                );
                        }
                        wprintf(L"\n");
                        pTmpBuf1++;
                        pTmpBuf= pTmpBuf1;
                    } else {
                        fprintf(stderr, "An internal error has occurred\n");
                    }

                    dwTotalCount++;
                }
            }
        }
        // Otherwise, indicate a system error.
        else {
            fprintf(stderr, "A system error has occurred: %d\n", nStatus);
        }
        // Free the allocated memory.
        if (pBuf != NULL)
        {
            NetApiBufferFree(pBuf);
            pBuf = NULL;
        }
    }
    // Continue to call NetWkstaUserEnum while 
    //  there are more entries. 
    while (nStatus == ERROR_MORE_DATA); // end do

    // Check again for allocated memory.
    if (pBuf != NULL)
       NetApiBufferFree(pBuf);
    // Print the final count of workstation users.
    fprintf(stderr, "\nTotal of %d entries enumerated\n", dwTotalCount);

}
